diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_invite.c ircd-hybrid-7-bg/modules/m_invite.c
--- ircd-hybrid-7rc5/modules/m_invite.c	Wed Jul 31 12:24:07 2002
+++ ircd-hybrid-7-bg/modules/m_invite.c	Sat May 24 23:27:10 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_invite.c,v 1.47 2002/07/31 16:24:07 leeh Exp $
+ *  $Id: m_invite.c,v 1.3 2003/05/24 00:07:45 demond Exp $
  */
 
 #include "stdinc.h"
@@ -42,6 +42,7 @@
 #include "parse.h"
 #include "modules.h"
 #include "packet.h"
+#include "s_misc.h"
 
 static void m_invite(struct Client *, struct Client *, int, char **);
 
@@ -63,7 +64,7 @@
   mod_del_cmd(&invite_msgtab);
 }
 
-const char *_version = "$Revision: 1.47 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 
 /*
@@ -83,9 +84,13 @@
   struct Channel *vchan2;
 #endif
 
+  cluster_prefix(client_p, parc, parv, 0, 0, 0);
+  cluster_prefix(client_p, parc, parv, 1, 0, 0);
+  cluster_prefix(client_p, parc, parv, 2, 1, 0);
+
   if (*parv[2] == '\0')
   {
-    sendto_one(source_p, form_str(ERR_NEEDMOREPARAMS),
+    sendto_one(source_p, form_str(source_p,ERR_NEEDMOREPARAMS),
                me.name, parv[0], "INVITE");
     return;
   }
@@ -98,21 +103,22 @@
 
   if ((target_p = find_person(parv[1])) == NULL)
   {
-    sendto_one(source_p, form_str(ERR_NOSUCHNICK), me.name, parv[0], parv[1]);
+    sendto_one(source_p, form_str(source_p,ERR_NOSUCHNICK), me.name, parv[0], parv[1]);
     return;
   }
 
   if(check_channel_name(parv[2]) == 0)
   {
-    sendto_one(source_p, form_str(ERR_BADCHANNAME),
+    sendto_one(source_p, form_str(source_p,ERR_BADCHANNAME),
                me.name, parv[0], (unsigned char *)parv[2]);
     return;
   }
 
+  if (!ServerInfo.gateway || !get_bridge_token(client_p))
   if (!IsChannelName(parv[2]))
   {
     if (MyClient(source_p))
-      sendto_one(source_p, form_str(ERR_NOSUCHCHANNEL),
+      sendto_one(source_p, form_str(source_p,ERR_NOSUCHCHANNEL),
                  me.name, parv[0], parv[2]);
     return;
   }
@@ -128,7 +134,7 @@
   if (!MyConnect(target_p) && (parv[2][0] == '&'))
   {
     if (ConfigServerHide.hide_servers == 0)
-      sendto_one(source_p, form_str(ERR_USERNOTONSERV),
+      sendto_one(source_p, form_str(source_p,ERR_USERNOTONSERV),
                  me.name, parv[0], parv[1]);
     return;
   }
@@ -136,7 +142,7 @@
   if ((chptr = hash_find_channel(parv[2])) == NULL)
   {
     if (MyClient(source_p))
-      sendto_one(source_p, form_str(ERR_NOSUCHCHANNEL),
+      sendto_one(source_p, form_str(source_p,ERR_NOSUCHCHANNEL),
                  me.name, parv[0], parv[2]);
     return;
   }
@@ -154,7 +160,7 @@
   
   if (MyClient(source_p) && !IsMember(source_p, vchan))
   {
-    sendto_one(source_p, form_str(ERR_NOTONCHANNEL), me.name, parv[0],
+    sendto_one(source_p, form_str(source_p,ERR_NOTONCHANNEL), me.name, parv[0],
                parv[2]);
     return;
   }
@@ -163,7 +169,7 @@
   if ((vchan2 = map_vchan(chptr, target_p)))
   {
     if (MyClient(source_p) && ((vchan2->mode.mode & MODE_SECRET) == 0))
-      sendto_one(source_p, form_str(ERR_USERONCHANNEL), me.name, parv[0],
+      sendto_one(source_p, form_str(source_p,ERR_USERONCHANNEL), me.name, parv[0],
                  parv[1], parv[2]);
     return;
   }
@@ -172,7 +178,7 @@
   if (IsMember(target_p, vchan))
   {
     if (MyClient(source_p))
-      sendto_one(source_p, form_str(ERR_USERONCHANNEL),
+      sendto_one(source_p, form_str(source_p,ERR_USERONCHANNEL),
                  me.name, parv[0], parv[1], parv[2]);
     return;
   }
@@ -184,7 +190,7 @@
     if (!chop)
     {
       if (MyClient(source_p))
-        sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED),
+        sendto_one(source_p, form_str(source_p,ERR_CHANOPRIVSNEEDED),
                    me.name, parv[0], parv[2]);
       return;
     }
@@ -195,10 +201,10 @@
 
   if (MyConnect(source_p))
   {
-    sendto_one(source_p, form_str(RPL_INVITING), me.name, parv[0],
+    sendto_one(source_p, form_str(source_p,RPL_INVITING), me.name, parv[0],
                target_p->name, parv[2]);
     if (target_p->user->away)
-      sendto_one(source_p, form_str(RPL_AWAY), me.name, parv[0],
+      sendto_one(source_p, form_str(source_p,RPL_AWAY), me.name, parv[0],
                  target_p->name, target_p->user->away);
   }
 
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_ison.c ircd-hybrid-7-bg/modules/m_ison.c
--- ircd-hybrid-7rc5/modules/m_ison.c	Fri May 24 19:34:20 2002
+++ ircd-hybrid-7-bg/modules/m_ison.c	Mon Mar 10 01:09:01 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_ison.c,v 1.28 2002/05/24 23:34:20 androsyn Exp $
+ *  $Id: m_ison.c,v 1.2 2003/03/10 06:09:01 demond Exp $
  */
 
 #include "stdinc.h"
@@ -61,7 +61,7 @@
 {
   mod_del_cmd(&ison_msgtab);
 }
-const char *_version = "$Revision: 1.28 $";
+const char *_version = "$Revision: 1.2 $";
 #endif
 
 static char buf[BUFSIZE];
@@ -82,6 +82,9 @@
 {
   struct Client *up = NULL;
 
+  if (client_p->user) 
+	  client_p->user->known = 1;
+
   if (!ServerInfo.hub && uplink && IsCapable(uplink, CAP_LL))
     up = uplink;
 
@@ -118,7 +121,7 @@
   current_insert_point2 = buf2;
   *buf2 = '\0';
 
-  ircsprintf(buf, form_str(RPL_ISON), me.name, parv[0]);
+  ircsprintf(buf, form_str(source_p,RPL_ISON), me.name, parv[0]);
   len = strlen(buf);
   current_insert_point = buf + len;
 
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_join.c ircd-hybrid-7-bg/modules/m_join.c
--- ircd-hybrid-7rc5/modules/m_join.c	Mon Oct 28 16:09:22 2002
+++ ircd-hybrid-7-bg/modules/m_join.c	Sat May 24 23:27:10 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_join.c,v 1.93 2002/10/28 21:09:22 bill Exp $
+ *  $Id: m_join.c,v 1.4 2003/05/24 00:07:45 demond Exp $
  */
 
 #include "stdinc.h"
@@ -42,6 +42,7 @@
 #include "msg.h"
 #include "parse.h"
 #include "modules.h"
+#include "s_misc.h"
 
 
 static void m_join(struct Client*, struct Client*, int, char**);
@@ -65,7 +66,7 @@
 {
   mod_del_cmd(&join_msgtab);
 }
-const char *_version = "$Revision: 1.93 $";
+const char *_version = "$Revision: 1.4 $";
 
 #endif
 static void do_join_0(struct Client *client_p, struct Client *source_p);
@@ -103,7 +104,7 @@
 
   if (*parv[1] == '\0')
     {
-      sendto_one(source_p, form_str(ERR_NEEDMOREPARAMS),
+      sendto_one(source_p, form_str(source_p,ERR_NEEDMOREPARAMS),
                  me.name, parv[0], "JOIN");
       return;
     }
@@ -134,7 +135,7 @@
 
       if(!check_channel_name(name))
       {
-        sendto_one(source_p, form_str(ERR_BADCHANNAME),
+        sendto_one(source_p, form_str(source_p,ERR_BADCHANNAME),
 	           me.name, source_p->name, (unsigned char*)name);
         continue;
       }
@@ -159,14 +160,14 @@
       /* check it begins with # or & */
       else if(!IsChannelName(name))
       {
-        sendto_one(source_p, form_str(ERR_NOSUCHCHANNEL),
+        sendto_one(source_p, form_str(source_p,ERR_NOSUCHCHANNEL),
 	           me.name, source_p->name, name);
 	continue;
       }
 
       if(ConfigServerHide.disable_local_channels && (*name == '&'))
       {
-        sendto_one(source_p, form_str(ERR_NOSUCHCHANNEL),
+        sendto_one(source_p, form_str(source_p,ERR_NOSUCHCHANNEL),
 	           me.name, source_p->name, name);
         continue;
       }
@@ -174,7 +175,7 @@
       /* check the length */
       if (strlen(name) > CHANNELLEN)
       {
-        sendto_one(source_p, form_str(ERR_BADCHANNAME),
+        sendto_one(source_p, form_str(source_p,ERR_BADCHANNAME),
 	           me.name, source_p->name, name);
 	continue;
       }
@@ -183,7 +184,7 @@
       if(find_channel_resv(name) &&
          !(IsOper(source_p) && ConfigChannel.oper_pass_resv))
 	{
-	  sendto_one(source_p, form_str(ERR_UNAVAILRESOURCE),
+	  sendto_one(source_p, form_str(source_p,ERR_UNAVAILRESOURCE),
 		     me.name, source_p->name, name);
           sendto_realops_flags(FLAGS_SPY, L_ALL,
                    "User %s (%s@%s) is attempting to join locally juped channel %s",
@@ -195,7 +196,7 @@
          (!IsOper(source_p) || (source_p->user->joined >=
 	                        ConfigChannel.max_chans_per_user*3)))
 	{
-	  sendto_one(source_p, form_str(ERR_TOOMANYCHANNELS),
+	  sendto_one(source_p, form_str(source_p,ERR_TOOMANYCHANNELS),
 		     me.name, parv[0], name);
 	  if(successful_join_count != 0)
 	    source_p->localClient->last_join_time = CurrentTime;
@@ -210,7 +211,7 @@
 	  if(splitmode && !IsOper(source_p) && (*name != '&') && 
              ConfigChannel.no_join_on_split)
 	  {
-	    sendto_one(source_p, form_str(ERR_UNAVAILRESOURCE),
+	    sendto_one(source_p, form_str(source_p,ERR_UNAVAILRESOURCE),
                        me.name, source_p->name, name);
 	    continue;
 	  }
@@ -251,7 +252,7 @@
 	  if(splitmode && !IsOper(source_p) && (*name != '&') && 
             (ConfigChannel.no_create_on_split || ConfigChannel.no_join_on_split))
 	  {
-	    sendto_one(source_p, form_str(ERR_UNAVAILRESOURCE),
+	    sendto_one(source_p, form_str(source_p,ERR_UNAVAILRESOURCE),
 	               me.name, source_p->name, name);
 	    continue;
 	  }
@@ -272,7 +273,7 @@
 	  /* So create it */
 	  if ((chptr = get_or_create_channel(source_p, name, NULL)) == NULL)
 	  {
-	    sendto_one(source_p, form_str(ERR_UNAVAILRESOURCE),
+	    sendto_one(source_p, form_str(source_p,ERR_UNAVAILRESOURCE),
 		       me.name, parv[0], name);
 	    continue;
 	  }
@@ -289,7 +290,7 @@
 
       if ((i = can_join(source_p, chptr, key)))
 	{
-	  sendto_one(source_p, form_str(i), me.name, parv[0], name);
+	  sendto_one(source_p, form_str(source_p,i), me.name, parv[0], name);
 	  successful_join_count++;
 	  continue;
 	}
@@ -358,7 +359,13 @@
 	  /* XXX just exactly who is going to be =on= this new channel
 	   * other than just the creator at this time? ? ?
 	   */
-	  sendto_channel_local(ALL_MEMBERS, chptr, ":%s!%s@%s JOIN :%s",
+      /* 
+      ** postpone notifying the channel, add to pace queue if necessary
+      */
+      if (PaceChannel(chptr) && (chptr->joins < MAX_PACEJOIN))
+		add_pace(chptr, source_p, root_chptr->chname, 1, 1);
+      else
+	  	sendto_channel_local(ALL_MEMBERS, chptr, ":%s!%s@%s JOIN :%s",
 			       source_p->name, source_p->username,
 			       source_p->host, root_chptr->chname);
       
@@ -385,28 +392,32 @@
       
       if (chptr->topic != NULL)
 	{
-	  sendto_one(source_p, form_str(RPL_TOPIC), me.name,
-		     parv[0], root_chptr->chname, chptr->topic);
+	  char foo[TOPICLEN]; strlcpy(foo, chptr->topic, TOPICLEN);
+	  sendto_one(source_p, form_str(source_p,RPL_TOPIC), me.name,
+		     parv[0], root_chptr->chname, 
+		     ConfigFileEntry.totaltrans?
+		     translate(source_p, foo) : chptr->topic);
 
           if (!(chptr->mode.mode & MODE_HIDEOPS) ||
               (flags & CHFL_CHANOP) || (flags & CHFL_HALFOP))
             {
-              sendto_one(source_p, form_str(RPL_TOPICWHOTIME),
+              sendto_one(source_p, form_str(source_p,RPL_TOPICWHOTIME),
                          me.name, parv[0], root_chptr->chname,
                          chptr->topic_info, chptr->topic_time);
             }
           else /* Hide from nonops */
             {
-               sendto_one(source_p, form_str(RPL_TOPICWHOTIME),
+               sendto_one(source_p, form_str(source_p,RPL_TOPICWHOTIME),
                          me.name, parv[0], root_chptr->chname,
                          me.name, chptr->topic_time);
             }
 	}
 
-      channel_member_names(source_p, chptr, root_chptr->chname, 1);
+      if (!(PaceChannel(chptr) && (chptr->joins < MAX_PACEJOIN)))
+      	channel_member_names(source_p, chptr, root_chptr->chname, 1);
 
       if(successful_join_count != 0)
-	source_p->localClient->last_join_time = CurrentTime;
+		source_p->localClient->last_join_time = CurrentTime;
     }
 }
 
@@ -428,6 +439,9 @@
 {
   char *name;
   int new_ts;
+  
+  cluster_prefix(client_p, parc, parv, 0, 0, 0);
+  cluster_prefix(client_p, parc, parv, 1, 1, 0);
 
   if ((source_p->user) == NULL)
     return;
@@ -485,7 +499,11 @@
   while ((lp = source_p->user->channel.head))
     {
       chptr = lp->data;
-      sendto_channel_local(ALL_MEMBERS,chptr, ":%s!%s@%s PART %s",
+
+      if (PaceChannel(chptr) && (chptr->parts < MAX_PACEJOIN))
+		add_pace(chptr, source_p, RootChan(chptr)->chname, 0, 0);
+      else
+      	sendto_channel_local(ALL_MEMBERS,chptr, ":%s!%s@%s PART %s",
 			   source_p->name, source_p->username,
 			   source_p->host, RootChan(chptr)->chname);
       remove_user_from_channel(chptr, source_p);
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_kline.c ircd-hybrid-7-bg/modules/m_kline.c
--- ircd-hybrid-7rc5/modules/m_kline.c	Wed Sep 11 18:01:05 2002
+++ ircd-hybrid-7-bg/modules/m_kline.c	Sat May 24 23:27:10 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_kline.c,v 1.110 2002/09/11 22:01:05 db Exp $
+ *  $Id: m_kline.c,v 1.3 2003/05/24 00:07:45 demond Exp $
  */
 
 #include "stdinc.h"
@@ -75,7 +75,7 @@
   mod_del_cmd(&kline_msgtab);
   mod_del_cmd(&dline_msgtab);
 }
-const char *_version = "$Revision: 1.110 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 
 /* Local function prototypes */
@@ -148,7 +148,7 @@
 
   if (parc == 0)
     {
-      sendto_one(source_p, form_str(ERR_NEEDMOREPARAMS),
+      sendto_one(source_p, form_str(source_p,ERR_NEEDMOREPARAMS),
 		 me.name, source_p->name, "KLINE");
       return;
     }
@@ -167,7 +167,7 @@
 	  parv++;
 	  if(parc == 0)
 	    {
-	      sendto_one(source_p, form_str(ERR_NEEDMOREPARAMS),
+	      sendto_one(source_p, form_str(source_p,ERR_NEEDMOREPARAMS),
 			 me.name, source_p->name, "KLINE");
 	      return;
 	    }
@@ -273,6 +273,9 @@
 
   if (parc != 6)
     return;
+    
+  if (ServerInfo.gateway && get_bridge_token(client_p))
+  	return;
 
   /* parv[0]  parv[1]        parv[2]      parv[3]  parv[4]  parv[5] */
   /* oper     target_server  tkline_time  user     host     reason */
@@ -981,7 +984,7 @@
    t = 0;
    piphost = NULL;
   }
-  if ((aconf = find_conf_by_address(lhost, piphost, CONF_KILL, t, luser)))
+  if ((aconf = find_conf_by_address(lhost, piphost, CONF_KILL, t, luser, NULL)))
   {
    reason = aconf->passwd ? aconf->passwd : "<No Reason>";
 
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_knock.c ircd-hybrid-7-bg/modules/m_knock.c
--- ircd-hybrid-7rc5/modules/m_knock.c	Thu Sep  5 02:05:40 2002
+++ ircd-hybrid-7-bg/modules/m_knock.c	Sat May 24 23:27:10 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_knock.c,v 1.52 2002/09/05 06:05:40 db Exp $
+ *  $Id: m_knock.c,v 1.3 2003/05/24 00:07:45 demond Exp $
  */
 
 #include "stdinc.h"
@@ -81,7 +81,7 @@
   mod_del_cmd(&knockll_msgtab);
 }
 
-const char *_version = "$Revision: 1.52 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 
 /* m_knock
@@ -111,7 +111,7 @@
   
   if((ConfigChannel.use_knock == 0) && MyClient(source_p))
     {
-      sendto_one(source_p, form_str(ERR_KNOCKDISABLED),
+      sendto_one(source_p, form_str(source_p,ERR_KNOCKDISABLED),
 		 me.name, source_p->name);
       return;
     }
@@ -155,6 +155,9 @@
 ms_knock(struct Client *client_p, struct Client *source_p,
 		     int parc, char *parv[])
 {
+  if (ServerInfo.gateway && get_bridge_token(client_p))
+  	return;
+
   if(IsClient(source_p))
     parse_knock_remote(client_p, source_p, parc, parv);
 }
@@ -194,7 +197,7 @@
 
   if(!IsChannelName(name))
   {
-    sendto_one(source_p, form_str(ERR_NOSUCHCHANNEL),
+    sendto_one(source_p, form_str(source_p,ERR_NOSUCHCHANNEL),
                me.name, parv[0], name);
     return;
   }
@@ -211,7 +214,7 @@
     }
     else
     {
-      sendto_one(source_p, form_str(ERR_NOSUCHCHANNEL), me.name, parv[0],
+      sendto_one(source_p, form_str(source_p,ERR_NOSUCHCHANNEL), me.name, parv[0],
                  name);
     }
 
@@ -224,7 +227,7 @@
     /* They specified a vchan basename */
     if(on_sub_vchan(chptr,source_p))
     {
-      sendto_one(source_p, form_str(ERR_KNOCKONCHAN),
+      sendto_one(source_p, form_str(source_p,ERR_KNOCKONCHAN),
 		 me.name, source_p->name, name);
       return;
     }
@@ -244,7 +247,7 @@
       }
       else
       {
-	sendto_one(source_p, form_str(ERR_NOSUCHCHANNEL),
+	sendto_one(source_p, form_str(source_p,ERR_NOSUCHCHANNEL),
 		   me.name, parv[0], name);
 	return;
       }
@@ -259,7 +262,7 @@
   else if (IsVchan(chptr))
   {
     /* Don't allow KNOCK'ing a vchans 'real' name */
-    sendto_one(source_p, form_str(ERR_BADCHANNAME), me.name, parv[0],
+    sendto_one(source_p, form_str(source_p,ERR_BADCHANNAME), me.name, parv[0],
 	       name);
     return;
   }
@@ -269,7 +272,7 @@
     /* Normal channel, just be sure they aren't on it */
     if (IsMember(source_p, chptr))
     {
-      sendto_one(source_p, form_str(ERR_KNOCKONCHAN),
+      sendto_one(source_p, form_str(source_p,ERR_KNOCKONCHAN),
 		 me.name, source_p->name, name);
       return;
     }
@@ -280,7 +283,7 @@
        (chptr->mode.limit && chptr->users >= chptr->mode.limit )
        ))
   {
-    sendto_one(source_p, form_str(ERR_CHANOPEN),
+    sendto_one(source_p, form_str(source_p,ERR_CHANOPEN),
 	       me.name, source_p->name, name);
     return;
   }
@@ -290,7 +293,7 @@
       (sockhost && is_banned_knock(chptr, source_p, sockhost)) ||
       (!sockhost && is_banned(chptr, source_p)))
   {
-    sendto_one(source_p, form_str(ERR_CANNOTSENDTOCHAN), me.name, parv[0],
+    sendto_one(source_p, form_str(source_p,ERR_CANNOTSENDTOCHAN), me.name, parv[0],
 	       name);
     return;
   }
@@ -304,14 +307,14 @@
   if(MyClient(source_p) &&
     (source_p->localClient->last_knock + ConfigChannel.knock_delay) > CurrentTime)
   {
-    sendto_one(source_p, form_str(ERR_TOOMANYKNOCK),
+    sendto_one(source_p, form_str(source_p,ERR_TOOMANYKNOCK),
                me.name, source_p->name, parv[1], "user");
     return;
   }
   else if((chptr->last_knock +
          ConfigChannel.knock_delay_channel) > CurrentTime)
   {
-    sendto_one(source_p, form_str(ERR_TOOMANYKNOCK),
+    sendto_one(source_p, form_str(source_p,ERR_TOOMANYKNOCK),
                me.name, source_p->name, parv[1], "channel");
     return;
   }
@@ -401,18 +404,18 @@
   {
     source_p->localClient->last_knock = CurrentTime;
 
-    sendto_one(source_p, form_str(RPL_KNOCKDLVR),
+    sendto_one(source_p, form_str(source_p,RPL_KNOCKDLVR),
                me.name, source_p->name, name);
   }
   else if(llclient == 1)
-    sendto_one(source_p, form_str(RPL_KNOCKDLVR),
+    sendto_one(source_p, form_str(source_p,RPL_KNOCKDLVR),
                me.name, source_p->name, name);
 
   if(source_p->user != NULL)
     {
       if(ConfigChannel.use_knock)
         sendto_channel_local(ONLY_CHANOPS_HALFOPS,
-  			     chptr, form_str(RPL_KNOCK),
+  			     chptr, form_str(NULL,RPL_KNOCK),
 			     me.name, name, name,
 			     source_p->name, source_p->username,
 			     source_p->host);
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_links.c ircd-hybrid-7-bg/modules/m_links.c
--- ircd-hybrid-7rc5/modules/m_links.c	Wed Jul 31 12:24:07 2002
+++ ircd-hybrid-7-bg/modules/m_links.c	Sat May 24 23:27:10 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_links.c,v 1.37 2002/07/31 16:24:07 leeh Exp $
+ *  $Id: m_links.c,v 1.3 2003/05/24 00:07:45 demond Exp $
  */
 
 #include "stdinc.h"
@@ -36,6 +36,7 @@
 #include "parse.h"
 #include "modules.h"
 #include "hook.h"
+#include "s_misc.h"
 
 
 static void m_links(struct Client*, struct Client*, int, char**);
@@ -62,7 +63,7 @@
   mod_del_cmd(&links_msgtab);
 }
 
-const char *_version = "$Revision: 1.37 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 /*
  * m_links - LINKS message handler
@@ -90,11 +91,11 @@
  * then print out the file (which may or may not be empty)
  */
   
-  sendto_one(source_p, form_str(RPL_LINKS),
+  sendto_one(source_p, form_str(source_p,RPL_LINKS),
                            me.name, parv[0], me.name, me.name,
                            0, me.info);
       
-  sendto_one(source_p, form_str(RPL_ENDOFLINKS), me.name, parv[0], "*");
+  sendto_one(source_p, form_str(source_p,RPL_ENDOFLINKS), me.name, parv[0], "*");
 }
 
 static void mo_links(struct Client *client_p, struct Client *source_p,
@@ -155,12 +156,12 @@
      /* We just send the reply, as if theyre here theres either no SHIDE,
       * or theyre an oper..  
       */
-      sendto_one(source_p, form_str(RPL_LINKS),
+      sendto_one(source_p, form_str(source_p,RPL_LINKS),
 		      me.name, parv[0], target_p->name, target_p->serv->up,
                       target_p->hopcount, p);
     }
   
-  sendto_one(source_p, form_str(RPL_ENDOFLINKS), me.name, parv[0],
+  sendto_one(source_p, form_str(source_p,RPL_ENDOFLINKS), me.name, parv[0],
              EmptyString(mask) ? "*" : mask);
 }
 
@@ -176,6 +177,8 @@
 static void ms_links(struct Client *client_p, struct Client *source_p,
                     int parc, char *parv[])
 {
+  cluster_prefix(client_p, parc, parv, 0, 0, 0);
+
   if (hunt_server(client_p, source_p, ":%s LINKS %s :%s", 1, parc, parv)
       != HUNTED_ISME)
     return;
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_list.c ircd-hybrid-7-bg/modules/m_list.c
--- ircd-hybrid-7rc5/modules/m_list.c	Thu Aug 15 11:00:59 2002
+++ ircd-hybrid-7-bg/modules/m_list.c	Mon Mar 10 01:09:01 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_list.c,v 1.44 2002/08/15 15:00:59 adx Exp $
+ *  $Id: m_list.c,v 1.2 2003/03/10 06:09:01 demond Exp $
  */
 
 #include "stdinc.h"
@@ -65,7 +65,7 @@
 {
   mod_del_cmd(&list_msgtab);
 }
-const char *_version = "$Revision: 1.44 $";
+const char *_version = "$Revision: 1.2 $";
 #endif
 static int list_all_channels(struct Client *source_p);
 static int list_named_channel(struct Client *source_p,char *name);
@@ -88,7 +88,7 @@
    * traffic involved in /list.. -- fl_ */
   if( ( (last_used + ConfigFileEntry.pace_wait) > CurrentTime) )
     {
-      sendto_one(source_p,form_str(RPL_LOAD2HI),me.name,parv[0]);
+      sendto_one(source_p,form_str(source_p,RPL_LOAD2HI),me.name,parv[0]);
       return;
     }
   else
@@ -190,7 +190,7 @@
 {
   struct Channel *chptr;
 
-  sendto_one(source_p, form_str(RPL_LISTSTART), me.name, source_p->name);
+  sendto_one(source_p, form_str(source_p,RPL_LISTSTART), me.name, source_p->name);
 
   for ( chptr = GlobalChannelList; chptr; chptr = chptr->nextch )
     {
@@ -200,7 +200,7 @@
       list_one_channel(source_p,chptr);
     }
 
-  sendto_one(source_p, form_str(RPL_LISTEND), me.name, source_p->name);
+  sendto_one(source_p, form_str(source_p,RPL_LISTEND), me.name, source_p->name);
   return 0;
 }   
           
@@ -221,7 +221,7 @@
   struct Channel *tmpchptr;
 #endif
 
-  sendto_one(source_p, form_str(RPL_LISTSTART), me.name, source_p->name);
+  sendto_one(source_p, form_str(source_p,RPL_LISTSTART), me.name, source_p->name);
 
   while (*name == ',')
     name++;
@@ -233,8 +233,8 @@
   chptr = hash_find_channel(name);
   if (chptr == NULL)
     {
-      sendto_one(source_p, form_str(ERR_NOSUCHNICK),me.name, source_p->name, name);
-      sendto_one(source_p, form_str(RPL_LISTEND), me.name, source_p->name);
+      sendto_one(source_p, form_str(source_p,ERR_NOSUCHNICK),me.name, source_p->name, name);
+      sendto_one(source_p, form_str(source_p,RPL_LISTEND), me.name, source_p->name);
       return 0;
     }
 
@@ -246,7 +246,7 @@
     ircsprintf(id_and_topic, "%s", chptr->topic == NULL ? "" : chptr->topic);
 
   if (ShowChannel(source_p, chptr))
-    sendto_one(source_p, form_str(RPL_LIST), me.name, source_p->name,
+    sendto_one(source_p, form_str(source_p,RPL_LIST), me.name, source_p->name,
                chptr->chname, chptr->users, id_and_topic);
       
   /* Deal with subvchans */
@@ -260,13 +260,13 @@
 	{
           root_chptr = find_bchan(tmpchptr);
           ircsprintf(id_and_topic, "<!%s> %s", pick_vchan_id(tmpchptr), tmpchptr->topic == NULL ? "" : chptr->topic);
-          sendto_one(source_p, form_str(RPL_LIST), me.name, source_p->name,
+          sendto_one(source_p, form_str(source_p,RPL_LIST), me.name, source_p->name,
                      root_chptr->chname, tmpchptr->users, id_and_topic);
         }
     }
 #endif
   
-  sendto_one(source_p, form_str(RPL_LISTEND), me.name, source_p->name);
+  sendto_one(source_p, form_str(source_p,RPL_LISTEND), me.name, source_p->name);
   return 0;
 }
 
@@ -291,20 +291,20 @@
       if(root_chptr != NULL)
         {
           ircsprintf(id_and_topic, "<!%s> %s", pick_vchan_id(chptr), chptr->topic == NULL ? "" : chptr->topic );
-          sendto_one(source_p, form_str(RPL_LIST), me.name, source_p->name,
+          sendto_one(source_p, form_str(source_p,RPL_LIST), me.name, source_p->name,
                      root_chptr->chname, chptr->users, id_and_topic);
         }
       else
         {
           ircsprintf(id_and_topic, "<!%s> %s", pick_vchan_id(chptr), chptr->topic == NULL ? "" : chptr->topic );
-          sendto_one(source_p, form_str(RPL_LIST), me.name, source_p->name,
+          sendto_one(source_p, form_str(source_p,RPL_LIST), me.name, source_p->name,
                      chptr->chname, chptr->users, id_and_topic);     
         }
     }
   else
 #endif
     {
-      sendto_one(source_p, form_str(RPL_LIST), me.name, source_p->name,
+      sendto_one(source_p, form_str(source_p,RPL_LIST), me.name, source_p->name,
                  chptr->chname, chptr->users, chptr->topic == NULL ? "" : chptr->topic );
     }
 }
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_lljoin.c ircd-hybrid-7-bg/modules/m_lljoin.c
--- ircd-hybrid-7rc5/modules/m_lljoin.c	Fri May 24 19:34:21 2002
+++ ircd-hybrid-7-bg/modules/m_lljoin.c	Mon Mar 10 01:09:01 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_lljoin.c,v 1.57 2002/05/24 23:34:21 androsyn Exp $
+ *  $Id: m_lljoin.c,v 1.2 2003/03/10 06:09:01 demond Exp $
  */
 
 #include "stdinc.h"
@@ -64,7 +64,7 @@
   mod_del_cmd(&lljoin_msgtab);
 }
 
-const char *_version = "$Revision: 1.57 $";
+const char *_version = "$Revision: 1.2 $";
 #endif
 /*
  * m_lljoin
@@ -212,7 +212,7 @@
     }
     else
     {
-      sendto_one(target_p, form_str(ERR_UNAVAILRESOURCE),
+      sendto_one(target_p, form_str(target_p,ERR_UNAVAILRESOURCE),
                  me.name, nick, root_vchan->chname);
       return;
     }
@@ -220,7 +220,7 @@
     if( (i = can_join(target_p, chptr, key)) )
     {
       sendto_one(target_p,
-                 form_str(i), me.name, nick, root_vchan->chname);
+                 form_str(target_p,i), me.name, nick, root_vchan->chname);
       return;
     }
   }
@@ -229,7 +229,7 @@
       (!IsOper(target_p) || (target_p->user->joined >= 
                              ConfigChannel.max_chans_per_user*3)))
     {
-      sendto_one(target_p, form_str(ERR_TOOMANYCHANNELS),
+      sendto_one(target_p, form_str(target_p,ERR_TOOMANYCHANNELS),
 		 me.name, nick, root_vchan->chname );
       return; 
     }
@@ -303,7 +303,10 @@
     add_vchan_to_client_cache(target_p,root_vchan,chptr);
 #endif
  
-  sendto_channel_local(ALL_MEMBERS, chptr,
+  if (PaceChannel(chptr) && (chptr->joins < MAX_PACEJOIN))
+    add_pace(chptr, target_p, root_vchan->chname, 1, 1);
+  else
+  	sendto_channel_local(ALL_MEMBERS, chptr,
 		       ":%s!%s@%s JOIN :%s",
 		       target_p->name,
 		       target_p->username,
@@ -323,5 +326,6 @@
                me.name, chptr->chname);
   }
 
-  channel_member_names(target_p, chptr, chname, 1);
+  if (!(PaceChannel(chptr) && (chptr->joins < MAX_PACEJOIN)))
+  	channel_member_names(target_p, chptr, chname, 1);
 }
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_llnick.c ircd-hybrid-7-bg/modules/m_llnick.c
--- ircd-hybrid-7rc5/modules/m_llnick.c	Fri May 24 19:34:21 2002
+++ ircd-hybrid-7-bg/modules/m_llnick.c	Mon Mar 10 01:09:01 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_llnick.c,v 1.20 2002/05/24 23:34:21 androsyn Exp $
+ *  $Id: m_llnick.c,v 1.2 2003/03/10 06:09:01 demond Exp $
  */
 
 #include "stdinc.h"
@@ -60,7 +60,7 @@
   mod_del_cmd(&llnick_msgtab);
 }
 
-const char *_version = "$Revision: 1.20 $";
+const char *_version = "$Revision: 1.2 $";
 #endif
 /*
  * m_llnick
@@ -134,7 +134,7 @@
   if(find_client(nick) || exists)
   {
     /* The nick they want is in use. complain */
-    sendto_one(target_p, form_str(ERR_NICKNAMEINUSE), me.name,
+    sendto_one(target_p, form_str(target_p,ERR_NICKNAMEINUSE), me.name,
                new ? "*" : nick_old,
                nick);
     return;
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_locops.c ircd-hybrid-7-bg/modules/m_locops.c
--- ircd-hybrid-7rc5/modules/m_locops.c	Fri May 24 19:34:21 2002
+++ ircd-hybrid-7-bg/modules/m_locops.c	Mon Mar 10 01:09:01 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_locops.c,v 1.27 2002/05/24 23:34:21 androsyn Exp $
+ *  $Id: m_locops.c,v 1.2 2003/03/10 06:09:01 demond Exp $
  */
 
 #include "stdinc.h"
@@ -56,7 +56,7 @@
   mod_del_cmd(&locops_msgtab);
 }
 
-const char *_version = "$Revision: 1.27 $";
+const char *_version = "$Revision: 1.2 $";
 #endif
 /*
  * m_locops - LOCOPS message handler
@@ -73,7 +73,7 @@
 
   if (EmptyString(message))
     {
-      sendto_one(source_p, form_str(ERR_NEEDMOREPARAMS),
+      sendto_one(source_p, form_str(source_p,ERR_NEEDMOREPARAMS),
                  me.name, parv[0], "LOCOPS");
       return;
     }
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_lusers.c ircd-hybrid-7-bg/modules/m_lusers.c
--- ircd-hybrid-7rc5/modules/m_lusers.c	Wed Jul 31 12:24:07 2002
+++ ircd-hybrid-7-bg/modules/m_lusers.c	Sat May 24 23:27:10 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_lusers.c,v 1.23 2002/07/31 16:24:07 leeh Exp $
+ *  $Id: m_lusers.c,v 1.3 2003/05/24 00:07:45 demond Exp $
  */
 
 #include "stdinc.h"
@@ -34,6 +34,7 @@
 #include "msg.h"
 #include "parse.h"
 #include "modules.h"
+#include "s_misc.h"
 
 /* XXX LazyLinks ? */
 
@@ -58,7 +59,7 @@
   mod_del_cmd(&lusers_msgtab);
 }
 
-const char *_version = "$Revision: 1.23 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 /*
  * m_lusers - LUSERS message handler
@@ -78,7 +79,7 @@
     {
       /* safe enough to give this on a local connect only */
       if (MyClient(source_p))
-        sendto_one(source_p, form_str(RPL_LOAD2HI), me.name, parv[0]);
+        sendto_one(source_p, form_str(source_p,RPL_LOAD2HI), me.name, parv[0]);
       return;
     }
   else
@@ -105,6 +106,8 @@
 static void ms_lusers(struct Client *client_p, struct Client *source_p,
                      int parc, char *parv[])
 {
+  cluster_prefix(client_p, parc, parv, 0, 0, 0);
+
   if (parc > 2)
     {
       if(hunt_server(client_p, source_p, ":%s LUSERS %s :%s", 2, parc, parv)
